MODULE StreetRacer;  (*Geschreven door Bart*)
  <* +M2ADDTYPES *>
  <* NOOPTIMIZE + *>  (* For the Debugger *)
  FROM IO IMPORT  WrStr, WrLn,RdKey;
  FROM Lib IMPORT Delay; (* Delay: let the program wait a little time *)
    IMPORT FIO; (*File import*)
  FROM Graph IMPORT Init, Rectangle,RawOutText, Update, SetUpdateMode,PutImage;
  FROM Graph IMPORT SetBkColor; (* for bitmap saving *)
  FROM MsMouse IMPORT InitMouse,MsData,GetStatus;
  FROM StandardBitmap IMPORT DrawSavedBitmap, DrawNumber;
  FROM Launcher IMPORT Help,Launch,sloc,InladenGegevens,Save;
  FROM Gegevens IMPORT SCREEN_SIZE_X,SCREEN_SIZE_Y,Gamer,Zwart,Wit,hx,hy;
  FROM Game IMPORT Rijden;
  FROM KiesAuto IMPORT KeuzeAuto;
  FROM KiesTrack IMPORT KeuzeTrack;
  FROM Afbeeldingen IMPORT LaadAfbeeldingenIn, ID1,ID2,ID5,ID7,ID9,ID11,ID12,ID13,DoneAfbeelding,MotorAfbeelding,TankinhoudAfbeelding,VersnellingsbakAfbeelding,RemmenAfbeelding;
  FROM Cars IMPORT Ferari,SportAuto,Vrachtwagen;

CONST
	f1=240;  (*begin hoogte op y-as*)
	f2=400;  (*eind hoogte op y-as*)
	f3=450;  (*begin hoogte tweede lijn op y-as*)
	f4=570;  (*eind hoogte tweede lijn op y-as*)
	g1=175;  (* x-breedte *)
	g2=85;   (*verschuiving x voor lijn twee*)
	hy2=690; (*Plaats eind y-as*)
	Cy=600; (*y waarde van de Credits bij Tune*)
	Cx=150; (*x waarde van de Credits bij Tune*) (*Cx en Cy worden in # procedures opgeroepen*)
	Prijs_Niveau1 = 3500;
	Prijs_Niveau2 = 5000;
	Prijs_Niveau3 = 7000;
	
	
VAR
	x,y:CARDINAL;
	b: BOOLEAN;
(*---------------------------------------------------------------*)
PROCEDURE Omlijn(x1,y1,x2,y2,dikte,color:CARDINAL);
BEGIN
Rectangle(x1-dikte,y1-dikte,x2+dikte,y1,color,TRUE);     (*Boven*)
Rectangle(x1-dikte,y1-dikte,x1,y2+dikte,color,TRUE);     (*Links*)
Rectangle(x2,y1-dikte,x2+dikte,y2+dikte,color,TRUE);	 (*Rechts*)
Rectangle(x1-dikte,y2,x2+dikte,y2+dikte,color,TRUE);	 (*Onder*)
END Omlijn;

(*----------------------------------------------------------------*)
PROCEDURE ToerijkendBudget(Prijs:CARDINAL):BOOLEAN;
BEGIN
IF Gamer.VerzameldePunten >= Prijs
THEN RETURN TRUE;
ELSE RETURN FALSE;
END; (*IF*)
END ToerijkendBudget;
(*----------------------------------------------------------------*)
PROCEDURE RawOutNiveau(Niveau,xpos1,ypos1,xpos2,ypos2:CARDINAL);
VAR   Prijs_Niveau:CARDINAL;
BEGIN
Rectangle(xpos1-10,ypos1-10,xpos2,ypos1+20,Wit,TRUE);
Rectangle(xpos1,ypos2,xpos2,ypos2+20,Wit,TRUE);
DrawNumber(xpos1,ypos1,Niveau,Zwart,Wit);
IF Niveau # 3 THEN
 CASE Niveau OF
  0: Prijs_Niveau:=Prijs_Niveau1;
 |1: Prijs_Niveau:=Prijs_Niveau2;
 |2: Prijs_Niveau:=Prijs_Niveau3;
 END; (*Case*)
 DrawNumber((xpos1+xpos2)/2,ypos2,Prijs_Niveau,Zwart,Wit);
ELSE RawOutText(xpos1,ypos2,Zwart,'Max Level!');
END; (*If*)
END RawOutNiveau;
(*----------------------------------------------------------------*)
PROCEDURE ControleerNiveauEnGeefPrijs;
CONST ypos1=250;
	  ypos2=500;
VAR  sNiveau,oNiveau,rNiveau,bNiveau:CARDINAL;
BEGIN
CASE Gamer.GekozenAutoNr OF
 0,1: CASE VAL(CARDINAL, SportAuto.MaxSnelheid) OF
 	 10: sNiveau:=0;
	|13: sNiveau:=1;
	|17: sNiveau:=2;
	|24: sNiveau:=3;
	END;
	CASE VAL(CARDINAL, SportAuto.OptrekSnelheid*100.0) OF
	 10: oNiveau:=0;
	|14: oNiveau:=1;
	|19: oNiveau:=2;
	|28: oNiveau:=3;
	END;
	CASE VAL(CARDINAL, SportAuto.RemSnelheid*10.0) OF
	 10: rNiveau:=0;
	|13: rNiveau:=1;
	|17: rNiveau:=2;
	|24: rNiveau:=3;
	END;
	CASE SportAuto.MaxBrandstof OF
	 200: bNiveau:=0;
	|250: bNiveau:=1;
	|325: bNiveau:=2;
	|425: bNiveau:=3;
	END;

|2:
	CASE VAL(CARDINAL, Ferari.MaxSnelheid) OF
 	 20: sNiveau:=0;
	|22: sNiveau:=1;
	|26: sNiveau:=2;
	|32: sNiveau:=3;
	END;
	CASE VAL(CARDINAL, Ferari.OptrekSnelheid*100.0) OF
	 30: oNiveau:=0;
	|32: oNiveau:=1;
	|36: oNiveau:=2;
	|42: oNiveau:=3;
	END;
	CASE VAL(CARDINAL, Ferari.RemSnelheid*10.0) OF
	 20: rNiveau:=0;
	|22: rNiveau:=1;
	|26: rNiveau:=2;
	|32: rNiveau:=3;
	END;
	CASE Ferari.MaxBrandstof OF
	 300: bNiveau:=0;
	|325: bNiveau:=1;
	|360: bNiveau:=2;
	|400: bNiveau:=3;
	END;
	
|3: CASE VAL(CARDINAL, Vrachtwagen.MaxSnelheid) OF
 	 5:  sNiveau:=0;
	|7:  sNiveau:=1;
	|11: sNiveau:=2;
	|19: sNiveau:=3;
	END;
	CASE VAL(CARDINAL, Vrachtwagen.OptrekSnelheid*100.0) OF
	 5:  oNiveau:=0;
	|7:  oNiveau:=1;
	|10: oNiveau:=2;
	|14: oNiveau:=3;
	END;
	CASE VAL(CARDINAL, Vrachtwagen.RemSnelheid*10.0) OF
	 5:  rNiveau:=0;
	|7:  rNiveau:=1;
	|10: rNiveau:=2;
	|14: rNiveau:=3;
	END;
	CASE Vrachtwagen.MaxBrandstof OF
	 500: bNiveau:=0;
	|550: bNiveau:=1;
	|650: bNiveau:=2;
	|800: bNiveau:=3;
	END;
END; (*Case*)
RawOutNiveau(sNiveau,50,ypos1,200,ypos2);
RawOutNiveau(bNiveau,200,ypos1,350,ypos2);
RawOutNiveau(oNiveau,350,ypos1,500,ypos2);
RawOutNiveau(rNiveau,500,ypos1,650,ypos2);
END ControleerNiveauEnGeefPrijs;
(*----------------------------------------------------------------*)
PROCEDURE Rc;
VAR a:CHAR;
BEGIN

SetUpdateMode(FALSE);
DrawSavedBitmap(0,0,ID2);
DrawSavedBitmap(100,250,ID12);
Update();

SetUpdateMode(TRUE);
a:=RdKey();

SetUpdateMode(FALSE);
Rijden();

END Rc;
(*----------------------------------------------------------------*)
PROCEDURE CarSlct;
BEGIN

ID9:=SetBkColor(Wit);
KeuzeAuto;

END CarSlct;
(*----------------------------------------------------------------*)
PROCEDURE Track;
BEGIN

ID9:=SetBkColor(Wit);
KeuzeTrack;

END Track;
(*----------------------------------------------------------------*)
PROCEDURE Tune;      (*Graphics By Jonathan*)
CONST     xWaarde =150;
		  yWaardeBoven=250;
		  yWaardeOnder=450;
		  x1WaardeDone=570;
		  x2WaardeDone=700;
		  y1WaardeDone=645;
		  y2WaardeDone=690;		
VAR Bln,Open,ReEnter:BOOLEAN;
	j:CARDINAL;
	MousePosition:MsData;
BEGIN
SetUpdateMode(FALSE);
DrawSavedBitmap(0,0,ID5);
Update();
SetUpdateMode(TRUE);
PutImage(SCREEN_SIZE_X-129, SCREEN_SIZE_Y-76, DoneAfbeelding, 1);
RawOutText(Cx,Cy,Zwart,'Credits: ');
DrawNumber(Cx+80,Cy+10,Gamer.VerzameldePunten,Zwart,Wit);
Bln:=FALSE;
ReEnter:=FALSE;
    ControleerNiveauEnGeefPrijs;
	RawOutText(xWaarde-40,SCREEN_SIZE_Y/2-75,Zwart,"Motor");         	
	RawOutText(xWaarde+85,SCREEN_SIZE_Y/2-75,Zwart,"Tankinhoud");
	RawOutText(xWaarde+215,SCREEN_SIZE_Y/2-75,Zwart,"Versnellingsbak");
	RawOutText(xWaarde+400,SCREEN_SIZE_Y/2-75,Zwart,"Remmen");
	
	DrawSavedBitmap(55,SCREEN_SIZE_Y/2-10,MotorAfbeelding);
	DrawSavedBitmap(210,SCREEN_SIZE_Y/2-10,TankinhoudAfbeelding);
	DrawSavedBitmap(360,SCREEN_SIZE_Y/2-10,VersnellingsbakAfbeelding);
	DrawSavedBitmap(505,SCREEN_SIZE_Y/2-10,RemmenAfbeelding);
	
	WHILE Bln=FALSE DO
	Delay(120);
	GetStatus(MousePosition);
		x:=MousePosition.col;
		y:=MousePosition.row;
	IF (y > yWaardeBoven) AND (y < yWaardeOnder)
	THEN Rectangle(0,yWaardeOnder,SCREEN_SIZE_X,yWaardeOnder+10,Wit,TRUE);
		 Rectangle(hx,hy,hx+5,hy2,Wit,TRUE);
		 Omlijn(x1WaardeDone,y1WaardeDone,x2WaardeDone,y2WaardeDone,5,Wit);
		FOR j:=0 TO 3 DO
			IF (x>50+j*xWaarde) AND (x<(50+(j+1)*xWaarde))
			THEN
			Rectangle(50+j*xWaarde,yWaardeOnder,50+(j+1)*xWaarde,yWaardeOnder+10,Zwart,TRUE);
			END;(*IF x*)
		END; (*FOR j*)	
	END;(*IF y*)
	(*Knop om Tune te verlaten aanduiden*)
	IF   (y >= y1WaardeDone) AND (y <= y2WaardeDone) AND (x > x1WaardeDone)  AND (x < x2WaardeDone)
	THEN Omlijn(x1WaardeDone,y1WaardeDone,x2WaardeDone,y2WaardeDone,5,Zwart);
			Rectangle(0,yWaardeOnder,SCREEN_SIZE_X,yWaardeOnder+10,Wit,TRUE);
		 	Rectangle(hx,hy,hx+5,hy2,Wit,TRUE);
	END; (*IF y*)
	IF (y>hy) AND (x<hx)
    THEN Rectangle(hx,hy,hx+5,hy2,Zwart,TRUE);
		 Omlijn(x1WaardeDone,y1WaardeDone,x2WaardeDone,y2WaardeDone,5,Wit);
		 Rectangle(0,yWaardeOnder,SCREEN_SIZE_X,yWaardeOnder+10,Wit,TRUE);
	END; (*IF y and x*)
	
	IF MousePosition.left_pressed  THEN
    	IF (y > yWaardeBoven) AND (y < yWaardeOnder)
		THEN FOR j:=0 TO 3 DO
			 IF (x>50+j*xWaarde) AND (x<(50+(j+1)*xWaarde))
			 THEN
			 	
				CASE j OF
				 0: CASE Gamer.GekozenAutoNr OF
				 	 0,1:CASE VAL(CARDINAL, SportAuto.MaxSnelheid) OF
 	 						 10: IF ToerijkendBudget(Prijs_Niveau1) THEN SportAuto.MaxSnelheid:=SportAuto.MaxSnelheid+3.0;
							 	 Gamer.VerzameldePunten:=Gamer.VerzameldePunten-Prijs_Niveau1;END;
							|13: IF ToerijkendBudget(Prijs_Niveau2) THEN SportAuto.MaxSnelheid:=SportAuto.MaxSnelheid+4.0;
								 Gamer.VerzameldePunten:=Gamer.VerzameldePunten-Prijs_Niveau2;END;
							|17: IF ToerijkendBudget(Prijs_Niveau3) THEN SportAuto.MaxSnelheid:=SportAuto.MaxSnelheid+7.0;
								 Gamer.VerzameldePunten:=Gamer.VerzameldePunten-Prijs_Niveau3;END;
							|24: Delay(50);
						END;
					|2:CASE VAL(CARDINAL, Ferari.MaxSnelheid) OF
 	 						 20: IF ToerijkendBudget(Prijs_Niveau1) THEN Ferari.MaxSnelheid:=Ferari.MaxSnelheid+2.0;
							 	 Gamer.VerzameldePunten:=Gamer.VerzameldePunten-Prijs_Niveau1;END;
							|22: IF ToerijkendBudget(Prijs_Niveau2) THEN Ferari.MaxSnelheid:=Ferari.MaxSnelheid+4.0;
								 Gamer.VerzameldePunten:=Gamer.VerzameldePunten-Prijs_Niveau2;END;
							|26: IF ToerijkendBudget(Prijs_Niveau3) THEN Ferari.MaxSnelheid:=Ferari.MaxSnelheid+6.0;
								Gamer.VerzameldePunten:=Gamer.VerzameldePunten-Prijs_Niveau3;END;
							|32: Delay(50);
					    END;
					|3: CASE VAL(CARDINAL, Vrachtwagen.MaxSnelheid) OF
 							 5:  IF ToerijkendBudget(Prijs_Niveau1) THEN Vrachtwagen.MaxSnelheid:=Vrachtwagen.MaxSnelheid+2.0;
							 	 Gamer.VerzameldePunten:=Gamer.VerzameldePunten-Prijs_Niveau1;END;
							|7:  IF ToerijkendBudget(Prijs_Niveau2) THEN Vrachtwagen.MaxSnelheid:=Vrachtwagen.MaxSnelheid+4.0;
								 Gamer.VerzameldePunten:=Gamer.VerzameldePunten-Prijs_Niveau2;END;
							|11: IF ToerijkendBudget(Prijs_Niveau3) THEN Vrachtwagen.MaxSnelheid:=Vrachtwagen.MaxSnelheid+8.0;
							     Gamer.VerzameldePunten:=Gamer.VerzameldePunten-Prijs_Niveau3;END;
							|19: Delay(50);
						END;
				    END; (*Case Gamer.GekozenAutoNr*)
					Bln:=TRUE; ReEnter:=TRUE;

				|1: CASE Gamer.GekozenAutoNr OF
					 0,1:	CASE SportAuto.MaxBrandstof OF
	 						 200: IF ToerijkendBudget(Prijs_Niveau1) THEN SportAuto.MaxBrandstof:=SportAuto.MaxBrandstof+50;
							 	 Gamer.VerzameldePunten:=Gamer.VerzameldePunten-Prijs_Niveau1;END;
							|250: IF ToerijkendBudget(Prijs_Niveau2) THEN SportAuto.MaxBrandstof:=SportAuto.MaxBrandstof+75;
								 Gamer.VerzameldePunten:=Gamer.VerzameldePunten-Prijs_Niveau2;END;
							|325: IF ToerijkendBudget(Prijs_Niveau3) THEN SportAuto.MaxBrandstof:=SportAuto.MaxBrandstof+100;
							    Gamer.VerzameldePunten:=Gamer.VerzameldePunten-Prijs_Niveau3;END;
							|425: Delay(50);
						END;
					|2: CASE Ferari.MaxBrandstof OF
						 	 300: IF ToerijkendBudget(Prijs_Niveau1) THEN Ferari.MaxBrandstof:=Ferari.MaxBrandstof+25;
							 	 Gamer.VerzameldePunten:=Gamer.VerzameldePunten-Prijs_Niveau1;END;
							|325: IF ToerijkendBudget(Prijs_Niveau2) THEN Ferari.MaxBrandstof:=Ferari.MaxBrandstof+35;
								 Gamer.VerzameldePunten:=Gamer.VerzameldePunten-Prijs_Niveau2;END;
							|360: IF ToerijkendBudget(Prijs_Niveau3) THEN Ferari.MaxBrandstof:=Ferari.MaxBrandstof+40;
							    Gamer.VerzameldePunten:=Gamer.VerzameldePunten-Prijs_Niveau3;END;
							|400: Delay(50);
						END;
					|3: CASE Vrachtwagen.MaxBrandstof OF
	 						 500: IF ToerijkendBudget(Prijs_Niveau1) THEN Vrachtwagen.MaxBrandstof:=Vrachtwagen.MaxBrandstof+50;
							 	 Gamer.VerzameldePunten:=Gamer.VerzameldePunten-Prijs_Niveau1;END;
							|550: IF ToerijkendBudget(Prijs_Niveau2) THEN Vrachtwagen.MaxBrandstof:=Vrachtwagen.MaxBrandstof+100;
								 Gamer.VerzameldePunten:=Gamer.VerzameldePunten-Prijs_Niveau2;END;
							|650: IF ToerijkendBudget(Prijs_Niveau3) THEN Vrachtwagen.MaxBrandstof:=Vrachtwagen.MaxBrandstof+150;
							    Gamer.VerzameldePunten:=Gamer.VerzameldePunten-Prijs_Niveau3;END;
							|800: Delay(50);
						END;						
				    END;
					Bln:=TRUE; ReEnter:=TRUE;
					
				|2: CASE Gamer.GekozenAutoNr OF
					0,1: CASE VAL(CARDINAL, SportAuto.OptrekSnelheid*100.0) OF
	 						 10: IF ToerijkendBudget(Prijs_Niveau1) THEN SportAuto.OptrekSnelheid:=SportAuto.OptrekSnelheid+0.04;
							 	 Gamer.VerzameldePunten:=Gamer.VerzameldePunten-Prijs_Niveau1;END;
							|14: IF ToerijkendBudget(Prijs_Niveau2) THEN SportAuto.OptrekSnelheid:=SportAuto.OptrekSnelheid+0.06;
								 Gamer.VerzameldePunten:=Gamer.VerzameldePunten-Prijs_Niveau2;END;
							|19: IF ToerijkendBudget(Prijs_Niveau3) THEN SportAuto.OptrekSnelheid:=SportAuto.OptrekSnelheid+0.09;
							    Gamer.VerzameldePunten:=Gamer.VerzameldePunten-Prijs_Niveau3;END;
							|28: Delay(50);
					   END;
					|2:	CASE VAL(CARDINAL, Ferari.OptrekSnelheid*100.0) OF
						 	 30: IF ToerijkendBudget(Prijs_Niveau1) THEN Ferari.OptrekSnelheid:=Ferari.OptrekSnelheid+0.02;
							 	 Gamer.VerzameldePunten:=Gamer.VerzameldePunten-Prijs_Niveau1;END;
							|32: IF ToerijkendBudget(Prijs_Niveau2) THEN Ferari.OptrekSnelheid:=Ferari.OptrekSnelheid+0.04;
								 Gamer.VerzameldePunten:=Gamer.VerzameldePunten-Prijs_Niveau2;END;
							|36: IF ToerijkendBudget(Prijs_Niveau3) THEN Ferari.OptrekSnelheid:=Ferari.OptrekSnelheid+0.06;
							    Gamer.VerzameldePunten:=Gamer.VerzameldePunten-Prijs_Niveau3;END;
							|42: Delay(50);
						END;
					|3: CASE VAL(CARDINAL, Vrachtwagen.OptrekSnelheid*100.0) OF
	 						 5:  IF ToerijkendBudget(Prijs_Niveau1) THEN Vrachtwagen.OptrekSnelheid:=Vrachtwagen.OptrekSnelheid+0.02;
							 	 Gamer.VerzameldePunten:=Gamer.VerzameldePunten-Prijs_Niveau1;END;
							|7:  IF ToerijkendBudget(Prijs_Niveau2) THEN Vrachtwagen.OptrekSnelheid:=Vrachtwagen.OptrekSnelheid+0.03;
								 Gamer.VerzameldePunten:=Gamer.VerzameldePunten-Prijs_Niveau2;END;
							|10: IF ToerijkendBudget(Prijs_Niveau3) THEN Vrachtwagen.OptrekSnelheid:=Vrachtwagen.OptrekSnelheid+0.04;
							    Gamer.VerzameldePunten:=Gamer.VerzameldePunten-Prijs_Niveau3;END;
							|14: Delay(50);
						END;		
				    END;
					Bln:=TRUE; ReEnter:=TRUE;
					
				|3: CASE Gamer.GekozenAutoNr OF
					0,1: 	CASE VAL(CARDINAL, SportAuto.RemSnelheid*10.0) OF
	 						 10: IF ToerijkendBudget(Prijs_Niveau1) THEN SportAuto.RemSnelheid:=SportAuto.RemSnelheid+0.4;
							 	 Gamer.VerzameldePunten:=Gamer.VerzameldePunten-Prijs_Niveau1;END;
							|14: IF ToerijkendBudget(Prijs_Niveau2) THEN SportAuto.RemSnelheid:=SportAuto.RemSnelheid+0.5;
								 Gamer.VerzameldePunten:=Gamer.VerzameldePunten-Prijs_Niveau2;END;
							|19: IF ToerijkendBudget(Prijs_Niveau3) THEN SportAuto.RemSnelheid:=SportAuto.RemSnelheid+0.5;
							    Gamer.VerzameldePunten:=Gamer.VerzameldePunten-Prijs_Niveau3;END;
							|24: Delay(50);
						END;
					|2: CASE VAL(CARDINAL, Ferari.RemSnelheid*10.0) OF
							 20: IF ToerijkendBudget(Prijs_Niveau1) THEN Ferari.RemSnelheid:=Ferari.RemSnelheid+0.2;
							 	 Gamer.VerzameldePunten:=Gamer.VerzameldePunten-Prijs_Niveau1;END;
							|22: IF ToerijkendBudget(Prijs_Niveau2) THEN Ferari.RemSnelheid:=Ferari.RemSnelheid+0.4;
								 Gamer.VerzameldePunten:=Gamer.VerzameldePunten-Prijs_Niveau2;END;
							|26: IF ToerijkendBudget(Prijs_Niveau3) THEN Ferari.RemSnelheid:=Ferari.RemSnelheid+0.6;
							    Gamer.VerzameldePunten:=Gamer.VerzameldePunten-Prijs_Niveau3;END;
							|32: Delay(50);
						END;
				 	|3: CASE VAL(CARDINAL, Vrachtwagen.RemSnelheid*10.0) OF
	 						 5:  IF ToerijkendBudget(Prijs_Niveau1) THEN Vrachtwagen.RemSnelheid:=Vrachtwagen.RemSnelheid+0.2;
							 	 Gamer.VerzameldePunten:=Gamer.VerzameldePunten-Prijs_Niveau1;END;
							|7:  IF ToerijkendBudget(Prijs_Niveau2) THEN Vrachtwagen.RemSnelheid:=Vrachtwagen.RemSnelheid+0.3;
								 Gamer.VerzameldePunten:=Gamer.VerzameldePunten-Prijs_Niveau2;END;
							|10: IF ToerijkendBudget(Prijs_Niveau3) THEN Vrachtwagen.RemSnelheid:=Vrachtwagen.RemSnelheid+0.4;
							    Gamer.VerzameldePunten:=Gamer.VerzameldePunten-Prijs_Niveau3;END;
							|14: Delay(50);
						END;
				    END;
					Bln:=TRUE; ReEnter:=TRUE;
					
				END;(*Case*)
			 END; (*IF x*)
			 END; (*FOR j*)
		ELSIF (y >= y1WaardeDone) AND (y <= y2WaardeDone) AND (x > x1WaardeDone)  AND (x < x2WaardeDone)
		THEN  Bln:=TRUE;
		ELSIF (y>hy) AND (x<hx)
		THEN  Open:=Help(Open,'Tune',3,hx+10,hy,SCREEN_SIZE_X-x1WaardeDone,SCREEN_SIZE_Y);
		END; (*IFy *)	
	END; (*IF mouseposition*)
	END; (*WHILE*)
IF ReEnter=TRUE THEN
Tune;
END; (*IF ReEnter*)
END Tune;
(*---------------------------------------------------------------*)
PROCEDURE Score;             (*Made by Jonathan*)

VAR  ScoreFile:FIO.File;
	 Arr: ARRAY [1..10] OF CARDINAL;
	 Scorenaam: ARRAY [0..12] OF CHAR;
	 i,p,x,y:CARDINAL ;
	 MousePosition: MsData;
	 Open:BOOLEAN;
BEGIN

SetUpdateMode(FALSE);
DrawSavedBitmap(0,0,ID7);
DrawSavedBitmap(SCREEN_SIZE_X-129, SCREEN_SIZE_Y-76, DoneAfbeelding);
Update();
SetUpdateMode(TRUE);



ScoreFile:=FIO.Open('TopscoreNamen.txt');
	FOR p:=1 TO 9 DO
	FIO.RdStr(ScoreFile,Scorenaam);
	RawOutText((SCREEN_SIZE_X/2)+30,(293+(20*p)),Zwart,Scorenaam);
	END;(*For p*)
FIO.Close(ScoreFile);

ScoreFile:=FIO.Open('Topscores.txt');
	FOR i:=1 TO 9 DO
	Arr[i]:=FIO.RdCard(ScoreFile);
	DrawNumber(((SCREEN_SIZE_X/2)-30),(300+(20*i)),Arr[i],Zwart,Wit);
	END; (*For i*)
	
FIO.Close(ScoreFile);

LOOP
	Delay(100);
	GetStatus(MousePosition);
	x:=MousePosition.col;
	y:=MousePosition.row;

	IF MousePosition.left_pressed  THEN
		IF (y>=SCREEN_SIZE_Y-76) AND (y<=SCREEN_SIZE_Y)  AND (x>=SCREEN_SIZE_X-129) AND (x<=SCREEN_SIZE_X) THEN   (*Done*)
			RETURN;
		ELSIF (y>hy) AND (x<hx)
		THEN  Open:=Help(Open,'Home',3,(hx+10),hy,(SCREEN_SIZE_X-200),SCREEN_SIZE_Y);
		END;
	END;
END;


END Score;
(*---------------------------------------------------------------*)
PROCEDURE Load;
BEGIN
SetUpdateMode(FALSE);
DrawSavedBitmap(0,0,ID11);
Update();
SetUpdateMode(TRUE);
InladenGegevens(sloc);
END Load;
(*---------------------------------------------------------------*)
PROCEDURE Home;
VAR     m: CARDINAL;
 	Open,ReEnter: BOOLEAN;
	MousePosition: MsData;
BEGIN
SetUpdateMode(FALSE);
DrawSavedBitmap(0,0,ID1);
DrawSavedBitmap(SCREEN_SIZE_X-hx,hy,ID13);
Update();
SetUpdateMode(TRUE);
b:=FALSE;
Open:=FALSE;
ReEnter:=FALSE;
RawOutText(520,20,Zwart,'In Game: ');
RawOutText(585,20,Zwart,Gamer.naam);
WHILE b=FALSE DO
Delay(50);
GetStatus(MousePosition);
x:=MousePosition.col;
y:=MousePosition.row;

IF   (y>f1) AND (y<f2)
THEN Rectangle(0,f2,700,f2+5,Wit,TRUE);
     Rectangle(0,f4,700,f4+5,Wit,TRUE);
     Rectangle(hx,hy,hx+5,hy2,Wit,TRUE);
	 Omlijn(SCREEN_SIZE_X-hx,hy,SCREEN_SIZE_X-10,SCREEN_SIZE_X-10,5,Wit);
	FOR m:=0 TO 3 DO
		IF (x>=(g1*m)) AND (x<(g1*(m+1)))
		THEN Rectangle(g1*m,f2,g1*(m+1),f2+5,Zwart,TRUE);
		END; (*IF x.....*)
	END; (*FOR m*)
END; (*IF*)

IF (y>f3) AND (y<f4)
THEN Rectangle(0,f4,700,f4+5,Wit,TRUE);
     Rectangle(0,f2,700,f2+5,Wit,TRUE);
     Rectangle(hx,hy,hx+5,hy2,Wit,TRUE);
	 Omlijn(SCREEN_SIZE_X-hx,hy,SCREEN_SIZE_X-10,SCREEN_SIZE_X-10,5,Wit);
	FOR m:=0 TO 2 DO
		IF   (x>=(g1*m+g2)) AND (x<=(g1*(m+1)+g2))
		THEN Rectangle(g1*m+g2,f4,(g1*(m+1)+g2),f4+5,Zwart,TRUE);
		END; (*IF x......*)
	END; (*FOR m*)
END; (*IF*)

IF (y>hy) AND (x<hx)
THEN Rectangle(hx,hy,hx+5,hy2,Zwart,TRUE);
     Rectangle(0,f4,700,f4+5,Wit,TRUE);
     Rectangle(0,f2,700,f2+5,Wit,TRUE);
	 Omlijn(SCREEN_SIZE_X-hx,hy,SCREEN_SIZE_X-10,SCREEN_SIZE_X-10,5,Wit);
END; (*IF*)

(*--Exit Button--*)
IF (y>(hy)) AND (x>(SCREEN_SIZE_X-hx))
THEN Rectangle(hx,hy,hx+5,hy2,Wit,TRUE);
     Rectangle(0,f4,700,f4+5,Wit,TRUE);
     Rectangle(0,f2,700,f2+5,Wit,TRUE);
	 Omlijn(SCREEN_SIZE_X-hx,hy,SCREEN_SIZE_X-10,SCREEN_SIZE_X-10,5,Zwart);
END; (*Exit Button*)

IF MousePosition.left_pressed  THEN
	IF (y>f1) AND (y<f2)  THEN
		FOR m := 0 TO 3 DO
			IF (x>(g1*m)) AND (x<(g1*(m+1)))
			THEN
			CASE m OF
			 0: b:=TRUE; Rc; ReEnter:=TRUE;
			|1: b:=TRUE; CarSlct;ReEnter:=TRUE;
			|2: b:=TRUE; Track;ReEnter:=TRUE;
			|3: b:=TRUE; Tune; ReEnter:=TRUE;
			END; (*CASE*)
			END;(*IF x....*)
		END; (*for m*)	
	ELSIF (y>f3) AND (y<f4)
	THEN
		FOR m:=0 TO 2 DO
			IF (x>(g1*m+g2)) AND (x<(g1*(m+1)+g2)) THEN
			CASE m OF
			 0: b:=TRUE;  Save;ReEnter:=TRUE;
			|1: b:=TRUE;  Score; ReEnter:=TRUE;
			|2: b:=TRUE;  Load;ReEnter:=TRUE;			
			END; (*CASE*)
			END; (*IF x....*)
		END; (*FOR m*)	
	ELSIF (y>hy) AND (x<hx)
	THEN  Open:=Help(Open,'Home',3,(hx+10),hy,(SCREEN_SIZE_X-hx),SCREEN_SIZE_Y);
	ELSIF (y>(hy)) AND (x>(SCREEN_SIZE_X-hx))
	THEN  b:=TRUE;
	
	END; (*IF y*)
END; (*IF mouse....left.pressed*)
END; (*While b*)
IF ReEnter=TRUE THEN
Home;
END;

END Home;

BEGIN
 IF NOT Init(1,1,SCREEN_SIZE_X,SCREEN_SIZE_Y)THEN WrStr("No mouse!");WrLn;
 RETURN;
 END;
 InitMouse();
 LaadAfbeeldingenIn;
 ID9:=SetBkColor(Wit);
 Launch;
 Home;

END StreetRacer.