<* WOFF + *>
<*+M2ADDTYPES   *>
IMPLEMENTATION MODULE track;
<* NOOPTIMIZE + *>


FROM IO IMPORT WrCard, WrChar, WrStr, WrLn, WrReal;
FROM Lib IMPORT RANDOM,Delay;
FROM StandardBitmap IMPORT DrawBitmapFile,DrawNumber, DrawMaskFile,DrawSavedBitmap;
FROM StandardLib IMPORT RandomCard, SetSeed;
FROM Gegevens IMPORT SCREEN_SIZE_X,SCREEN_SIZE_Y, gAfstand, gAutoPositieX, gAutoPositieY, SnelheidAndereAutos, LengteGeparkeerdeAuto,BreedteGeparkeerdeAuto, LengteRijdendeAuto, BreedteRijdendeAuto, LengteGastank, BreedteGastank, LengteBoom, BreedteBoom,BreedteExplosie,LengteExplosie;
FROM Graph IMPORT Init,_clrWHITE,_clrBLACK,SetUpdateMode, Update, PutImage, ClearScreen,Rectangle, _clrGREEN, _clrRED,RawOutText, Line, Circle, SetBkColor;
FROM RealMath IMPORT sin,cos, tan,pi;
FROM Cars IMPORT Auto, Ferari, SportAuto;
FROM Gegevens IMPORT gTijdsArray, Gamer;
FROM SysClock IMPORT GetClock,DateTime;
FROM Afbeeldingen IMPORT ExplosieAfbeelding;



PROCEDURE CleangMatrixBaan();   (*Made by: Jonathan*)
VAR i,j: CARDINAL;
BEGIN
	FOR i:=0 TO LengteTrack DO
	 FOR j:=0 TO SCREEN_SIZE_X DO
	 	gMatrixBaan[i][j]:='';
	 END;
	END;
END CleangMatrixBaan;


PROCEDURE RandomizeTrack(VAR dubbelmatrix:MatrixBaan; Moeilijkheidsgraad : CARDINAL);     (*Made by: Jonathan*)
(*Deze procedure zet de objecten in de race op een random plaats die wordt bijgehouden in de matrix matrixbaan*)

	VAR
		PositieX,PositieY,i,j: CARDINAL; (*variabele declaraties: PositieX en PositieY worden zowel voor bomen,gastankjes en geparkeerde auto's gebruikt.*)
		VAR Dataclock : DateTime;
	
	BEGIN
	GetClock(Dataclock);
	SetSeed(Dataclock.fractions*10);
	FOR PositieY:=0 TO LengteTrack BY 20  DO
	
		 		(*Random Bomen*)
				
				IF RandomCard(0,65-Moeilijkheidsgraad*6)<6 THEN     (* Nagaan of er al dan niet een boom moet staan*)
	 					PositieX:=RandomCard(0,SCREEN_SIZE_X/10*2)+RandomCard(0,1)*SCREEN_SIZE_X/10*7;
			   	   dubbelmatrix[PositieY][PositieX]:='B';
				   	
				END;
				
				(*Random gastankjes*)
					
				IF RandomCard(0,20+Moeilijkheidsgraad*8)<1 THEN     (* Nagaan of er al dan niet een gastankje moet staan*)
	 					PositieX:=SCREEN_SIZE_X/10*3+RandomCard(0,SCREEN_SIZE_X/10*3);
						dubbelmatrix[PositieY][PositieX]:='G';

				END;
				
				(*Random geparkeerde auto's*)
				
				IF RandomCard(0,100-Moeilijkheidsgraad*9)<1 THEN     (* Nagaan of er al dan niet een geparkeerde auto moet staan*)
	 					PositieX:=SCREEN_SIZE_X/10*3+RandomCard(0,1)*(SCREEN_SIZE_X/10*4-BreedteGeparkeerdeAuto);
						dubbelmatrix[PositieY][PositieX]:='P';
						
				END;
				
				
				(*Random rijdende auto's*)
				
				IF RandomCard(0,120-Moeilijkheidsgraad*11)<1 THEN
					IF PositieY > LengteRijdendeAuto
					THEN
						PositieX:=RandomCard(SCREEN_SIZE_X/10*3+BreedteGeparkeerdeAuto,SCREEN_SIZE_X/10*7-BreedteGeparkeerdeAuto-BreedteRijdendeAuto);
						dubbelmatrix[PositieY][PositieX]:='A';
					END;
		
						
				END;
				
		END; (* for *)
				
(*	
i:=1;		
WHILE i < LengteTrack  DO (* Stippenlijn *)
   gMatrixStippenlijn[i]:= 'S';
   i:=i+2*AfstandStippenlijn;
   WrLn;
END;   *)

END RandomizeTrack;

PROCEDURE DeleteNearObjects(MatrixPositieY,MatrixPositieX, LengteObject, BreedteObject : CARDINAL; X: CHAR);        (*Made by Jonathan*)
VAR i,j: CARDINAL;
BEGIN

FOR j:=MatrixPositieY TO MatrixPositieY+LengteObject DO
	FOR i:=  MatrixPositieX TO MatrixPositieX+BreedteObject DO
		gMatrixBaan[j][i]:='';   (*Alles wissen in dit object+object zelf. Alle plaatsen worden dus gewist, waar later plaats ingenomen zal worden door de bitmap, die uiteraard geen 1x1 pixel is, zodat er geen 2 bitmaps op elkaar vallen*)
		gMatrixBaan[j-LengteObject][i]:='';  (*Alle plaatsen boven het object worden gewist, want als er net boven deze bitmap een andere bitmap wordt geplaatst, dan ligt hij met zijn onderkant op deze bitmap*)
		gMatrixBaan[j][i-BreedteObject]:='';  (*Alle plaatsen links van het object worden gewist, want als er links van deze bitmap een andere bitmap wordt geplaatst dan staat hij gedeeltelijk  rechts op deze bitmap*)
	END; (*FOR*)
END; (*FOR*)

gMatrixBaan[MatrixPositieY][MatrixPositieX]:=X; (*Terugplaatsen object, dat nu verzekerd is om zijn bitmap te plaatsen op een plaats waar er nog geen bitmap staat*)

END DeleteNearObjects;


PROCEDURE CheckForObjectsInTrack;    (*Made by Jonathan*)
VAR PositieX,PositieY: CARDINAL;
BEGIN

FOR PositieY:=LengteRijdendeAuto*2 TO LengteTrack-LengteRijdendeAuto*2  DO     							(*RijdendeAuto = langste object -> tegen overflows aan randen van de matrix*)
	FOR PositieX:=BreedteRijdendeAuto*2 TO SCREEN_SIZE_X-BreedteRijdendeAuto*2 DO                    (*RijdendeAuto = breedste object -> tegen overflows aan randen van de matrix*)
	  IF gMatrixBaan[PositieY, PositieX]#'' THEN
			CASE gMatrixBaan[PositieY, PositieX]  OF
			 'B': DeleteNearObjects(PositieY,PositieX,LengteBoom,BreedteBoom, gMatrixBaan[PositieY, PositieX]);
			|'G': DeleteNearObjects(PositieY,PositieX,LengteGastank,BreedteGastank, gMatrixBaan[PositieY, PositieX]);
			|'P': DeleteNearObjects(PositieY,PositieX,LengteGeparkeerdeAuto,BreedteGeparkeerdeAuto, gMatrixBaan[PositieY, PositieX]);
			|'A': DeleteNearObjects(PositieY,PositieX,LengteRijdendeAuto,BreedteRijdendeAuto, gMatrixBaan[PositieY, PositieX]);
			|'F': ;
			END; (*CASE*)
		END; (*IF*)
					
	END; (*FOR*)
END; (*FOR*)

END CheckForObjectsInTrack;


PROCEDURE ObjectRanden(Letter: CHAR; LengteObject, BreedteObject: CARDINAL );  (*Made by: Jonathan*)
	VAR x_pos_matrix,y_pos_matrix, BitmapSizeX, BitmapSizeY : CARDINAL;
BEGIN
	FOR y_pos_matrix:=LengteObject TO (LengteTrack-LengteObject-10) DO
		FOR x_pos_matrix:=BreedteObject TO (SCREEN_SIZE_X-BreedteObject-10) DO
		
		(*matrix vullen met kleine letters (afh v.h. object) om aan te duiden waar het object staat*)
			IF gMatrixBaan[y_pos_matrix][x_pos_matrix]=Letter THEN
				FOR BitmapSizeY:=1 TO LengteObject DO
					FOR BitmapSizeX:=1 TO BreedteObject DO
						gMatrixBaan[y_pos_matrix-BitmapSizeY][BitmapSizeX+x_pos_matrix]:=CHR(ORD(Letter)+32);		
					END;
				END;
			END; (*if*)	
			
		END;
	END;
	
END ObjectRanden;





PROCEDURE ObjectRandenRijdendeAuto;  (*Made by: Robin*)
	VAR x_pos_matrix,y_pos_matrix, BitmapSizeX, BitmapSizeY : CARDINAL;
BEGIN
		
		
	FOR y_pos_matrix:=(gAfstand+2*SCREEN_SIZE_Y) TO (gAfstand+LengteRijdendeAuto) BY -1 DO
		FOR x_pos_matrix:=(SCREEN_SIZE_X/10*6+BreedteRijdendeAuto) TO (SCREEN_SIZE_X/10*4-BreedteRijdendeAuto) BY -1  DO
		(*matrix vullen met kleine letters (afh v.h. object) om aan te duiden waar het object staat*)
			IF gMatrixBaan[y_pos_matrix][x_pos_matrix]='A'
				THEN  gMatrixBaan[y_pos_matrix][x_pos_matrix]:='';
	        		IF (y_pos_matrix+SnelheidAndereAutos) < LengteTrack
				THEN  IF (gMatrixBaan[y_pos_matrix+SnelheidAndereAutos][x_pos_matrix] = 'a')   OR (gMatrixBaan[y_pos_matrix+SnelheidAndereAutos][x_pos_matrix] = 'P')
				      THEN
				      	FOR  BitmapSizeY:=1 TO LengteRijdendeAuto DO
					  FOR BitmapSizeX:=1 TO BreedteRijdendeAuto DO
					  							
					   gMatrixBaan[y_pos_matrix-BitmapSizeY][BitmapSizeX+x_pos_matrix]:='';
								
					  END;
				        END;
				      	
			              ELSE gMatrixBaan[y_pos_matrix+SnelheidAndereAutos][x_pos_matrix]:='A';
			
					FOR BitmapSizeY:=1 TO SnelheidAndereAutos DO
					  FOR BitmapSizeX:=1 TO BreedteRijdendeAuto DO
					
					    IF gMatrixBaan[y_pos_matrix+BitmapSizeY-LengteRijdendeAuto][BitmapSizeX+x_pos_matrix] = 'a'
					    THEN  gMatrixBaan[y_pos_matrix+BitmapSizeY-LengteRijdendeAuto][BitmapSizeX+x_pos_matrix]:='';
					    END;
					   	
					    IF (gMatrixBaan[y_pos_matrix+BitmapSizeY][BitmapSizeX+x_pos_matrix] = '')
                                            THEN   gMatrixBaan[y_pos_matrix+BitmapSizeY][BitmapSizeX+x_pos_matrix]:='a';
					    END;
					    		
					   END;
					 END;
					
				       END;
				  END;
				
     			END; (*if*)	
	    END;
	END;
	
END ObjectRandenRijdendeAuto;


PROCEDURE CrashTenzijGasTank(VAR Snelheid: REAL; y_pos_scherm, x_pos_scherm : CARDINAL; Zijkantbotsing : REAL);   (*Made by: Jonathan*)
BEGIN
	IF (gMatrixBaan[y_pos_scherm][x_pos_scherm] = 'g') OR (gMatrixBaan[y_pos_scherm][x_pos_scherm] = 'G') THEN
	   gMatrixBaan[y_pos_scherm][x_pos_scherm]:='';
			IF Gamer.GekozenAuto.Brandstof < Gamer.GekozenAuto.MaxBrandstof THEN Gamer.GekozenAuto.Brandstof:=Gamer.GekozenAuto.Brandstof+1;  END;
						
	ELSE
			PutImage(x_pos_scherm-BreedteExplosie,gAutoPositieY-LengteExplosie,ExplosieAfbeelding,0);
			IF Gamer.GekozenAuto.DamageMeter >  Gamer.GekozenAuto.Zwakte*Snelheid THEN
				Gamer.GekozenAuto.DamageMeter:= Gamer.GekozenAuto.DamageMeter - Gamer.GekozenAuto.Zwakte*Snelheid; (*- Zijkantbotsing*Gamer.GekozenAuto.Zwakte*VAL(REAL,Gamer.GekozenAuto.ZijwaartseSnelheid); *)
				Snelheid:=0.0;
			ELSE Gamer.GekozenAuto.DamageMeter:=0.0; Snelheid:=0.0;
			END;	
				
	END; (*eerste if*)
	
END CrashTenzijGasTank;


PROCEDURE TestCrash(VAR Snelheid: REAL);     (*Made by: Jonathan*)
VAR i: CARDINAL;
	b: BOOLEAN;

BEGIN
	(*test voorkant*)
	b:=FALSE;
	FOR i:=1 TO Gamer.GekozenAuto.Breedte DO
		IF gMatrixBaan[gAfstand+SCREEN_SIZE_Y-gAutoPositieY][gAutoPositieX+i] # ''  THEN   CrashTenzijGasTank(Snelheid,gAfstand+SCREEN_SIZE_Y-gAutoPositieY,gAutoPositieX+i,0.0);				
		END;
	END;
	
(*	(*test resp. linkerkant en rechterkant*)
	FOR i:=1 TO Gamer.GekozenAuto.Lengte DO
		IF gMatrixBaan[gAfstand+SCREEN_SIZE_Y-gAutoPositieY-i][gAutoPositieX] # ''  THEN   CrashTenzijGasTank(Snelheid,gAfstand+SCREEN_SIZE_Y-gAutoPositieY-i,gAutoPositieX,1.0);
		ELSIF gMatrixBaan[gAfstand+SCREEN_SIZE_Y-gAutoPositieY-i][gAutoPositieX+Gamer.GekozenAuto.Breedte] # ''  THEN   CrashTenzijGasTank(Snelheid,gAfstand+SCREEN_SIZE_Y-gAutoPositieY-i,gAutoPositieX+Gamer.GekozenAuto.Breedte,1.0);								
		END;
	END;    *) (* Deze test van de linker en rechterkant maakt het spel te moeilijk*)

END TestCrash;

PROCEDURE SnelheidsMeter(Snelheid:REAL);
	VAR  S: CARDINAL;

BEGIN

	(*Digitaal: Made By Robin*)
	S:=VAL(CARDINAL,Snelheid*20.0);
	DrawNumber(SCREEN_SIZE_X/20*19, SCREEN_SIZE_Y/30, S, 15, _clrBLACK);

	(*Analoog: Made By Jonathan*)
	Circle(SCREEN_SIZE_X/20*17+20, SCREEN_SIZE_Y/29, 18, 14);
	Line(SCREEN_SIZE_X/20*17+20, SCREEN_SIZE_Y/29, VAL(LONGCARD, VAL(REAL,SCREEN_SIZE_X)/20.0*17.0+20.0  +  14.0*cos(Snelheid/3.0+90.0)  ), VAL(LONGCARD,  VAL(REAL,SCREEN_SIZE_Y)/29.0  +  14.0*sin(Snelheid/3.0+90.0)  ) , 13);
	(*Naam: Made By Jonathan*)
	RawOutText(SCREEN_SIZE_X/20*15+5, SCREEN_SIZE_Y/31-5, 15, "Speed");

END SnelheidsMeter;
	

PROCEDURE OlieMeter();

BEGIN

	(*Digitaal: Made By Robin*)
	DrawNumber(SCREEN_SIZE_X/20*19, SCREEN_SIZE_Y/30+35, Gamer.GekozenAuto.Brandstof, 15, _clrBLACK);

	(*Analoog: Made By Jonathan*)
	Rectangle (SCREEN_SIZE_X/20*17,SCREEN_SIZE_Y/30+30 , SCREEN_SIZE_X/20*17+Gamer.GekozenAuto.MaxBrandstof/10*Gamer.GekozenAuto.MeterGrootte,  SCREEN_SIZE_Y/30+40,8, FALSE);
	Rectangle (SCREEN_SIZE_X/20*17,SCREEN_SIZE_Y/30+30 , SCREEN_SIZE_X/20*17+Gamer.GekozenAuto.Brandstof/10*Gamer.GekozenAuto.MeterGrootte,  SCREEN_SIZE_Y/30+40,8, TRUE);
	(*Naam: Made By Jonathan*)
	RawOutText(SCREEN_SIZE_X/20*15+5, SCREEN_SIZE_Y/31+30, 15, "Benzine");
	
END OlieMeter;




PROCEDURE DamageMeter();
	VAR verhouding: REAL;

BEGIN


	(*Digitaal: Made By Robin*)
	DrawNumber(SCREEN_SIZE_X/20*19, SCREEN_SIZE_Y/30+70, VAL(CARDINAL,Gamer.GekozenAuto.DamageMeter), 15, _clrBLACK);

	(*Analoog: Made By Jonathan*)
	verhouding:=VAL(REAL,Gamer.GekozenAuto.MaxBrandstof)/Gamer.GekozenAuto.MaxDamageMeter;
	Rectangle (SCREEN_SIZE_X/20*17,SCREEN_SIZE_Y/30+65 , SCREEN_SIZE_X/20*17+VAL(CARDINAL,Gamer.GekozenAuto.MaxDamageMeter/10.0*verhouding)*Gamer.GekozenAuto.MeterGrootte,  SCREEN_SIZE_Y/30+75,13, FALSE);
	Rectangle (SCREEN_SIZE_X/20*17,SCREEN_SIZE_Y/30+65 , SCREEN_SIZE_X/20*17+VAL(CARDINAL,Gamer.GekozenAuto.DamageMeter/10.0*verhouding)*Gamer.GekozenAuto.MeterGrootte,  SCREEN_SIZE_Y/30+75,13, TRUE);
   (*Naam: Made By Jonathan*)
	RawOutText(SCREEN_SIZE_X/20*15+5, SCREEN_SIZE_Y/31+65, 15, "Damage");

END DamageMeter;

PROCEDURE ChronoMeter();     (*Made By Jonathan*)
	VAR VerstrekenTijd,VerstrekenSeconden,VerstrekenHonderdstenseconden,Achtergrondkleur : CARDINAL;
BEGIN
	(*Digitaal*)
	Achtergrondkleur:=SetBkColor(_clrBLACK);
	VerstrekenTijd:=VAL(CARDINAL,gTijdsArray[2]-gTijdsArray[0]);                     (*Deze variabelen werden aangemaakt om de code wat leesbaarder te maken*)
	VerstrekenSeconden:=VAL(CARDINAL,VerstrekenTijd/100);
	VerstrekenHonderdstenseconden:=VerstrekenTijd-VerstrekenSeconden*100;
	DrawNumber(SCREEN_SIZE_X/20*19-10, SCREEN_SIZE_Y/30+105, VerstrekenSeconden, 15, _clrBLACK);  RawOutText(SCREEN_SIZE_X/20*19+2, SCREEN_SIZE_Y/30+101, 15,","); DrawNumber(SCREEN_SIZE_X/20*19+15, SCREEN_SIZE_Y/30+105, VerstrekenHonderdstenseconden, 15, _clrBLACK);
	(*Analoog*)
	Circle(SCREEN_SIZE_X/20*17+20, SCREEN_SIZE_Y/30+105, 18, 14);
	Line(SCREEN_SIZE_X/20*17+20, SCREEN_SIZE_Y/30+105, VAL(LONGCARD, VAL(REAL,SCREEN_SIZE_X)/20.0*17.0+20.0  +  14.0*sin(VAL(REAL,VerstrekenSeconden)*2.0*pi/60.0)  ), VAL(LONGCARD,  VAL(REAL,SCREEN_SIZE_Y)/30.0+105.0  -  14.0*cos(VAL(REAL,VerstrekenSeconden)*2.0*pi/60.0)  ) , 13);
   (*Naam*)
	RawOutText(SCREEN_SIZE_X/20*15+5, SCREEN_SIZE_Y/31+100, 15, "Time");
		
END ChronoMeter;

PROCEDURE LevelDisplayer();    (*Made by: Jonathan*)
BEGIN
	Rectangle(0, SCREEN_SIZE_Y-20,65,SCREEN_SIZE_Y,_clrBLACK,TRUE);
	RawOutText(0, SCREEN_SIZE_Y-20, 15, "Track");
	DrawNumber(55, SCREEN_SIZE_Y-13, Gamer.Track, 15, _clrBLACK);
END LevelDisplayer;


PROCEDURE Achtergrond;       (*Made by: Robin*)

BEGIN

Rectangle(SCREEN_SIZE_X/10*3 ,0, SCREEN_SIZE_X/10*7, SCREEN_SIZE_Y, _clrBLACK, TRUE);
Rectangle(0 ,0 , SCREEN_SIZE_X/10*3, SCREEN_SIZE_Y, _clrGREEN, TRUE);
Rectangle(SCREEN_SIZE_X/10*7 ,0 , SCREEN_SIZE_X, SCREEN_SIZE_Y, _clrGREEN, TRUE);

END Achtergrond;


END track.